/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.eppleton.nbexamples.nodes.async;


import java.awt.BorderLayout;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.util.NbBundle.Messages;
import java.util.List;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.view.BeanTreeView;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.ChildFactory;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.Exceptions;
import org.openide.windows.TopComponent;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(
    dtd = "-//de.eppleton.nbexamples.nodes.async//NodeDisplayer//EN",
autostore = false)
@TopComponent.Description(
    preferredID = "NodeDisplayerTopComponent",
//iconBase="SET/PATH/TO/ICON/HERE", 
persistenceType = TopComponent.PERSISTENCE_ALWAYS)
@TopComponent.Registration(mode = "explorer", openAtStartup = true)
@ActionID(category = "Window", id = "de.eppleton.nbexamples.nodes.async.NodeDisplayerTopComponent")
@ActionReference(path = "Menu/Window" /*, position = 333 */)
@TopComponent.OpenActionRegistration(
    displayName = "#CTL_NodeDisplayerAction",
preferredID = "NodeDisplayerTopComponent")
@Messages({
    "CTL_NodeDisplayerAction=NodeDisplayer",
    "CTL_NodeDisplayerTopComponent=NodeDisplayer Window",
    "HINT_NodeDisplayerTopComponent=This is a NodeDisplayer window"
})
public final class NodeDisplayerTopComponent extends TopComponent implements ExplorerManager.Provider {

    ExplorerManager em = new ExplorerManager();

    public NodeDisplayerTopComponent() {
        initComponents();
        setName(Bundle.CTL_NodeDisplayerTopComponent());
        setToolTipText(Bundle.HINT_NodeDisplayerTopComponent());

        setLayout(new BorderLayout());
        add(new BeanTreeView(), BorderLayout.CENTER);
        AbstractNode root = new AbstractNode(Children.create(new ChildFactory<String>() {
            @Override
            protected boolean createKeys(List<String> toPopulate) {
                try {
                    Thread.sleep(1000);
                    toPopulate.add("Tom");
                    Thread.sleep(1000);
                    toPopulate.add("Dick");
                    Thread.sleep(1000);
                    toPopulate.add("Harry");
                    Thread.sleep(1000);
                    toPopulate.add("Sally");
                    Thread.sleep(1000);
                    toPopulate.add("Carlos");
                    Thread.sleep(1000);
                    toPopulate.add("Frank");
                    Thread.sleep(1000);
                    toPopulate.add("Peter");
                    Thread.sleep(1000);
                    toPopulate.add("Toni");
                } catch (InterruptedException ex) {
                    Exceptions.printStackTrace(ex);
                }
                return true;
            }

            @Override
            protected Node createNodeForKey(String key) {
                AbstractNode node = new AbstractNode(Children.LEAF);
                node.setName(key);
                return node;
            }
        }, true));
        em.setRootContext(root);

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    @Override
    public void componentOpened() {
        // TODO add custom code on component opening
    }

    @Override
    public void componentClosed() {
        // TODO add custom code on component closing
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "1.0");
        // TODO store your settings
    }

    void readProperties(java.util.Properties p) {
        String version = p.getProperty("version");
        // TODO read your settings according to their version
    }

    @Override
    public ExplorerManager getExplorerManager() {
        return em;
    }
}
